#include "panel.h"
#include "esc.h"
#include "handler.h"
#include <stdio.h>

cui
cui_panel_new(cui parent, int x, int y, int w, int h)
{
	cui obj = cui_alloc(sizeof(struct cui_panel));
	cui_panel_init(obj, parent, x, y, w, h);
	return obj;
}

int
cui_panel_hdr(cui obj, int evt, int val, void *prm)
{
	int x, y;

	for(y=0; y<obj->h; y++){
		for(x=0; x<obj->w; x++){
			cui_draw_str(obj, x, y, " ", CUI_ESC_NORMAL);
		}
	}
	for(x=1; x<obj->w-1; x++){
		cui_draw_str(obj, x, 0, "-", CUI_ESC_NORMAL);
		cui_draw_str(obj, x, obj->h-1, "-", CUI_ESC_NORMAL);
	}
	for(y=1; y<obj->h-1; y++){
		cui_draw_str(obj, 0, y, "|", CUI_ESC_NORMAL);
		cui_draw_str(obj, obj->w-1, y, "|", CUI_ESC_NORMAL);
	}	
	cui_draw_str(obj, 0, 0, "+", CUI_ESC_NORMAL);
	cui_draw_str(obj, obj->w-1, 0, "+", CUI_ESC_NORMAL);
	cui_draw_str(obj, obj->w-1, obj->h-1, "+", CUI_ESC_NORMAL);
	cui_draw_str(obj, 0, obj->h-1, "+", CUI_ESC_NORMAL);
	return TRUE;
}

void
cui_panel_init(cui obj, cui parent, int x, int y, int w, int h)
{
	cui_base_init(obj, parent, x, y, w, h);
	cui_bind(obj, CUI_EVT_DRAW, cui_panel_hdr, NULL);
}

/* EOF */
